<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet version="1.0" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">
	<xsl:template match="/">
		<html>
			<head/>
			<body>
				<xsl:for-each select="filmation">
					<xsl:for-each select="name">
						<span style="font-size:large; font-weight:bold">
							<xsl:apply-templates/>
						</span>
					</xsl:for-each>
					<xsl:for-each select="hint">
						<xsl:if test="position()=1">
							<xsl:text disable-output-escaping="yes">&lt;ul&gt;</xsl:text>
						</xsl:if>
						<li>
							<xsl:apply-templates/>
						</li>
						<xsl:if test="position()=last()">
							<xsl:text disable-output-escaping="yes">&lt;/ul&gt;</xsl:text>
						</xsl:if>
					</xsl:for-each>
					<span style="font-size:large; font-style:normal; font-weight:bold">Rooms</span>
					<br/>
					<xsl:for-each select="rooms">
						<span style="font-weight:bold">Startup Rooms</span>
						<br/>
						<br/>
						<xsl:for-each select="startuprooms">
							<xsl:if test="position()=1">
								<table border="0">
									<xsl:if test="position()=1">
										<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
									</xsl:if>
									<tr>
										<xsl:for-each select="../startuprooms">
											<td>
												<xsl:for-each select="startuproomid">
													<xsl:if test="position()=1">
														<xsl:text disable-output-escaping="yes">&lt;ul&gt;</xsl:text>
													</xsl:if>
													<li>
														<xsl:apply-templates/>
													</li>
													<xsl:if test="position()=last()">
														<xsl:text disable-output-escaping="yes">&lt;/ul&gt;</xsl:text>
													</xsl:if>
												</xsl:for-each>
											</td>
										</xsl:for-each>
									</tr>
									<xsl:if test="position()=last()">
										<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
									</xsl:if>
								</table>
							</xsl:if>
						</xsl:for-each>
						<xsl:for-each select="room">
							<br/>
							<span style="font-weight:bold">Room Number:</span>
							<xsl:for-each select="roomid">
								<xsl:apply-templates/>
							</xsl:for-each> <br/>
							<span style="font-weight:bold">Size:</span>
							<xsl:for-each select="size">
								<xsl:apply-templates/>
							</xsl:for-each>
							<br/>
							<span style="font-weight:bold">Special Here:</span>
							<xsl:for-each select="specialhere">
								<xsl:apply-templates/>
							</xsl:for-each>
							<span style="font-weight:bold"> </span>
							<br/> <br/>
							<span style="font-weight:bold">Links</span>
							<br/>
							<xsl:for-each select="links">
								<span style="border-style:solid; border-width:thin">
									<xsl:if test="position()=1">
										<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
									</xsl:if>
									<xsl:if test="position()=1">
										<thead>
											<tr>
												<td>
													<span style="border-style:none; border-width:thin; font-weight:bold">linknorth</span>
													<span style="border-style:none; border-width:thin; font-weight:bold"></span>
												</td>
												<td>
													<span style="border-style:none; border-width:thin; font-weight:bold">linkeast</span>
													<span style="border-style:none; border-width:thin; font-weight:bold"></span>
												</td>
												<td>
													<span style="border-style:none; border-width:thin; font-weight:bold">linksouth</span>
													<span style="border-style:none; border-width:thin; font-weight:bold"></span>
												</td>
												<td>
													<span style="border-style:none; border-width:thin; font-weight:bold">linkwest</span>
												</td>
											</tr>
										</thead>
									</xsl:if>
									<xsl:if test="position()=1">
										<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
									</xsl:if>
									<tr>
										<td height="27">
											<xsl:for-each select="linknorth">
												<span style="border-style:none; border-width:thin">
													<span style="border-style:none; border-width:thin">
														<xsl:apply-templates/>
													</span>
												</span>
											</xsl:for-each>
										</td>
										<td height="27">
											<xsl:for-each select="linkeast">
												<span style="border-style:none; border-width:thin">
													<span style="border-style:none; border-width:thin">
														<xsl:apply-templates/>
													</span>
												</span>
											</xsl:for-each>
										</td>
										<td height="27">
											<xsl:for-each select="linksouth">
												<span style="border-style:none; border-width:thin">
													<span style="border-style:none; border-width:thin">
														<xsl:apply-templates/>
													</span>
												</span>
											</xsl:for-each>
										</td>
										<td height="27">
											<xsl:for-each select="linkwest">
												<span style="border-style:none; border-width:thin">
													<span style="border-style:none; border-width:thin">
														<xsl:apply-templates/>
													</span>
												</span>
											</xsl:for-each>
										</td>
									</tr>
									<xsl:if test="position()=last()">
										<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
									</xsl:if>
									<xsl:if test="position()=last()">
										<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
									</xsl:if>
								</span>
							</xsl:for-each>
							<br/>
							<span style="font-weight:bold">Background Items</span>
							<br/>
							<xsl:for-each select="backgrounds">
								<xsl:for-each select="backgroundobject">
									<xsl:if test="position()=1">
										<xsl:text disable-output-escaping="yes">&lt;ul&gt;</xsl:text>
									</xsl:if>
									<li>
										<xsl:apply-templates/>
									</li>
									<xsl:if test="position()=last()">
										<xsl:text disable-output-escaping="yes">&lt;/ul&gt;</xsl:text>
									</xsl:if>
								</xsl:for-each>
							</xsl:for-each>
							<br/>
							<span style="font-weight:bold">Room Objects</span>
							<br/>
							<br/>
							<xsl:for-each select="objects">
								<xsl:for-each select="roomblocks">
									<span style="border-style:solid; border-width:thin">
										<xsl:for-each select="roomblock">
											<span style="border-style:solid; border-width:thin">
												<xsl:if test="position()=1">
													<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
												</xsl:if>
												<xsl:if test="position()=1">
													<thead>
														<tr>
															<td>
																<span style="border-style:none; border-width:thin">objecttypeid</span>
																<span style="border-style:none; border-width:thin"></span>
															</td>
															<td>
																<span style="border-style:none; border-width:thin">x</span>
																<span style="border-style:none; border-width:thin"></span>
															</td>
															<td>
																<span style="border-style:none; border-width:thin">y</span>
																<span style="border-style:none; border-width:thin"></span>
															</td>
															<td>
																<span style="border-style:none; border-width:thin">z</span>
																<span style="border-style:none; border-width:thin"></span>
															</td>
															<td>
																<span style="border-style:none; border-width:thin">xoffset</span>
																<span style="border-style:none; border-width:thin"></span>
															</td>
															<td>
																<span style="border-style:none; border-width:thin">yoffset</span>
															</td>
															<td>
																<span style="border-style:none; border-width:thin">zpixeloffset</span>
															</td>
														</tr>
													</thead>
												</xsl:if>
												<xsl:if test="position()=1">
													<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
												</xsl:if>
												<tr>
													<td>
														<xsl:for-each select="objecttypeid">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
													<td>
														<xsl:for-each select="x">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
													<td>
														<xsl:for-each select="y">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
													<td>
														<xsl:for-each select="z">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
													<td>
														<xsl:for-each select="xoffset">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
													<td>
														<xsl:for-each select="yoffset">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
													<td>
														<xsl:for-each select="zpixeloffset">
															<span style="border-style:none; border-width:thin">
																<span style="border-style:none; border-width:thin">
																	<xsl:apply-templates/>
																</span>
															</span>
														</xsl:for-each>
													</td>
												</tr>
												<xsl:if test="position()=last()">
													<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
												</xsl:if>
												<xsl:if test="position()=last()">
													<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
												</xsl:if>
											</span>
										</xsl:for-each>
									</span>
								</xsl:for-each>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<br/>
					<br/>
					<span style="font-weight:bold">Specials</span>
					<br/>
					<xsl:for-each select="rooms">
						<xsl:for-each select="specials">
							<xsl:for-each select="special">
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=1">
									<thead>
										<tr>
											<td>roomlocation</td>
											<td>x</td>
											<td>y</td>
											<td>z</td>
										</tr>
									</thead>
								</xsl:if>
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
								</xsl:if>
								<tr>
									<td>
										<xsl:for-each select="roomlocation">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="x">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="y">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="z">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
								</tr>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<br/>
					<br/>
					<br/>
					<span style="font-weight:bold">Template</span>
					<br/>
					<span style="font-weight:bold">Room Sizes</span>
					<br/>
					<xsl:for-each select="template">
						<xsl:for-each select="roomsizes">
							<xsl:for-each select="roomsize">
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=1">
									<thead>
										<tr>
											<td>roomtype</td>
											<td>x</td>
											<td>y</td>
											<td>z</td>
										</tr>
									</thead>
								</xsl:if>
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
								</xsl:if>
								<tr>
									<td>
										<xsl:for-each select="roomtype">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="x">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="y">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="z">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
								</tr>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
						<br/>
						<br/>
						<span style="font-weight:bold">Background Types</span>
						<br/>
						<br/>
						<xsl:for-each select="backgroundtypes">
							<xsl:for-each select="backgrounditem">
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=1">
									<thead>
										<tr>
											<td>bgtype</td>
											<td>causesexit</td>
											<td>id</td>
											<td>bitmap</td>
											<td>name</td>
										</tr>
									</thead>
								</xsl:if>
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
								</xsl:if>
								<tr>
									<td>
										<xsl:for-each select="bgtype">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="causesexit">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="id">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="bitmap">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="name">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
								</tr>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
						<br/>
						<br/>
						<span style="font-weight:bold">Room Blocks</span>
						<br/>
						<xsl:for-each select="blocks">
							<xsl:for-each select="blocktype">
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;table border="1"&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=1">
									<thead>
										<tr>
											<td>id</td>
											<td>bitmap</td>
											<td>name</td>
											<td>movementtype</td>
											<td>extra</td>
										</tr>
									</thead>
								</xsl:if>
								<xsl:if test="position()=1">
									<xsl:text disable-output-escaping="yes">&lt;tbody&gt;</xsl:text>
								</xsl:if>
								<tr>
									<td>
										<xsl:for-each select="id">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="bitmap">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="name">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="movementtype">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
									<td>
										<xsl:for-each select="extra">
											<xsl:apply-templates/>
										</xsl:for-each>
									</td>
								</tr>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/tbody&gt;</xsl:text>
								</xsl:if>
								<xsl:if test="position()=last()">
									<xsl:text disable-output-escaping="yes">&lt;/table&gt;</xsl:text>
								</xsl:if>
							</xsl:for-each>
						</xsl:for-each>
					</xsl:for-each>
					<xsl:for-each select="rooms">
						<xsl:for-each select="startuprooms">
							<xsl:if test="position()=1">
								<xsl:text disable-output-escaping="yes">&lt;ul&gt;</xsl:text>
							</xsl:if>
							<li>
								<xsl:apply-templates/>
							</li>
							<xsl:if test="position()=last()">
								<xsl:text disable-output-escaping="yes">&lt;/ul&gt;</xsl:text>
							</xsl:if>
						</xsl:for-each>
					</xsl:for-each>
				</xsl:for-each>
			</body>
		</html>
	</xsl:template>
</xsl:stylesheet>
