using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace Retrospec.IsoConverter
{
	/// <summary>
	/// Summary description for objectdetails.
	/// </summary>
	public class objectdetails : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.ListBox ListObjects;
		private System.Windows.Forms.ListBox ListX;
		private System.Windows.Forms.ListBox ListY;
		private System.Windows.Forms.ListBox ListZ;
		private System.Windows.Forms.Button ButtonOK;
		private System.Windows.Forms.Button ButtonCancel;

		private IsoData ParentData;
		private Room ActiveRoom;
		private System.Windows.Forms.PictureBox pictureBox1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public objectdetails()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		public void InitialiseData(IsoData parent,Room room,string BlockType,bool editMode)
		{
			InitialiseData(parent,room,BlockType,editMode,0,0,0,false,false);
		}

		public void InitialiseData(IsoData parent,Room room,string BlockType,bool editMode, int x, int y, int z,bool xoff, bool yoff)
		{
			this.ParentData=parent;
			this.ActiveRoom=room;
			int maxx=((RoomSize)(ParentData.RoomSizes[ActiveRoom.Size])).x/8;
			int maxy=((RoomSize)(ParentData.RoomSizes[ActiveRoom.Size])).y/8;

			ListX.Items.Clear();
			ListY.Items.Clear();
			
			for(int i=0;i<maxx;i++) this.ListX.Items.Add(i);
			for(int i=0;i<maxy;i++) this.ListY.Items.Add(i);

			ListX.SelectedIndex=x;
			ListY.SelectedIndex=y;

			PopulateBlocks(BlockType,editMode);
			ListZ.SelectedIndex=ListZ.FindString(z.ToString());

			if(editMode) this.ListObjects.Enabled=false;
			return;
		}

		private void PopulateBlocks(string BlockType,bool editMode)
		{
			int item=-1;
			this.ListObjects.Items.Clear();
			foreach(BlockDescriptor BlockToUse in ParentData.DefinedBlocks)
			{
				if(BlockToUse.Type==1) 
				{
					if(ParentData.UsingControlExtension && BlockToUse.Number==ParentData.ControlExtensionCode)
					{
						//ignore as control block extension
					}
					else
					{
						if(ParentData.UsingBlockExtension && BlockToUse.Number==ParentData.BlockExtensionCode)
						{
							//ignore as block extension
						}
						else
						{
							this.ListObjects.Items.Add(BlockToUse.Name);
						}
					}
				}
				if(BlockType==BlockToUse.Name+" ("+BlockToUse.Number+")") item=this.ListObjects.Items.Count-1;
			}
			if(item==-1 && editMode) 
			{
				this.ListObjects.Enabled=false;
				this.ButtonOK.Enabled=false;
				MessageBox.Show("Block not found in list! error I suspect");
			}
			else
				this.ListObjects.SelectedIndex=item;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(objectdetails));
			this.label1 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label4 = new System.Windows.Forms.Label();
			this.ListObjects = new System.Windows.Forms.ListBox();
			this.ListX = new System.Windows.Forms.ListBox();
			this.ListY = new System.Windows.Forms.ListBox();
			this.ListZ = new System.Windows.Forms.ListBox();
			this.ButtonOK = new System.Windows.Forms.Button();
			this.ButtonCancel = new System.Windows.Forms.Button();
			this.pictureBox1 = new System.Windows.Forms.PictureBox();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(8, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(80, 16);
			this.label1.TabIndex = 0;
			this.label1.Text = "Object";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(320, 8);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(47, 16);
			this.label2.TabIndex = 1;
			this.label2.Text = "Z";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(264, 8);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(56, 16);
			this.label3.TabIndex = 2;
			this.label3.Text = "Y";
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(208, 8);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(47, 16);
			this.label4.TabIndex = 3;
			this.label4.Text = "X";
			// 
			// ListObjects
			// 
			this.ListObjects.Location = new System.Drawing.Point(8, 24);
			this.ListObjects.Name = "ListObjects";
			this.ListObjects.Size = new System.Drawing.Size(176, 329);
			this.ListObjects.TabIndex = 4;
			this.ListObjects.SelectedIndexChanged += new System.EventHandler(this.ListObjects_SelectedIndexChanged);
			// 
			// ListX
			// 
			this.ListX.Location = new System.Drawing.Point(192, 24);
			this.ListX.Name = "ListX";
			this.ListX.Size = new System.Drawing.Size(43, 147);
			this.ListX.TabIndex = 5;
			// 
			// ListY
			// 
			this.ListY.Location = new System.Drawing.Point(248, 24);
			this.ListY.Name = "ListY";
			this.ListY.Size = new System.Drawing.Size(43, 147);
			this.ListY.TabIndex = 6;
			// 
			// ListZ
			// 
			this.ListZ.Location = new System.Drawing.Point(304, 24);
			this.ListZ.Name = "ListZ";
			this.ListZ.Size = new System.Drawing.Size(43, 147);
			this.ListZ.TabIndex = 7;
			// 
			// ButtonOK
			// 
			this.ButtonOK.Location = new System.Drawing.Point(272, 328);
			this.ButtonOK.Name = "ButtonOK";
			this.ButtonOK.TabIndex = 11;
			this.ButtonOK.Text = "Ok";
			this.ButtonOK.Click += new System.EventHandler(this.ButtonOK_Click);
			// 
			// ButtonCancel
			// 
			this.ButtonCancel.Location = new System.Drawing.Point(192, 328);
			this.ButtonCancel.Name = "ButtonCancel";
			this.ButtonCancel.TabIndex = 12;
			this.ButtonCancel.Text = "Cancel";
			this.ButtonCancel.Click += new System.EventHandler(this.ButtonCancel_Click);
			// 
			// pictureBox1
			// 
			this.pictureBox1.Image = ((System.Drawing.Image)(resources.GetObject("pictureBox1.Image")));
			this.pictureBox1.Location = new System.Drawing.Point(192, 184);
			this.pictureBox1.Name = "pictureBox1";
			this.pictureBox1.Size = new System.Drawing.Size(160, 136);
			this.pictureBox1.TabIndex = 13;
			this.pictureBox1.TabStop = false;
			// 
			// objectdetails
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(354, 359);
			this.Controls.Add(this.pictureBox1);
			this.Controls.Add(this.ButtonCancel);
			this.Controls.Add(this.ButtonOK);
			this.Controls.Add(this.ListZ);
			this.Controls.Add(this.ListY);
			this.Controls.Add(this.ListX);
			this.Controls.Add(this.ListObjects);
			this.Controls.Add(this.label4);
			this.Controls.Add(this.label3);
			this.Controls.Add(this.label2);
			this.Controls.Add(this.label1);
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.Name = "objectdetails";
			this.Text = "objectdetails";
			this.ResumeLayout(false);

		}
		#endregion

		private void ButtonOK_Click(object sender, System.EventArgs e)
		{
			if(this.ListObjects.SelectedIndex>=0 && this.ListX.SelectedIndex>=0 && this.ListY.SelectedIndex>=0 && this.ListZ.SelectedIndex>=0)
			{
				this.Tag=true;
				this.Hide();
			}
			else
			{
				MessageBox.Show(this,"You need to specify name,x,y,z");
			}
		}

		private void ButtonCancel_Click(object sender, System.EventArgs e)
		{
			this.Tag="";
			this.Hide();
		}

		private void ListObjects_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			int maxz=7;
			int minz=0;
			
			ListZ.Items.Clear();
			if(!ParentData.UsingControlExtension)
			{
				//knightlore
				//not using control extension so the z size is dependant upon the block
				BlockDescriptor BlockToUse=ParentData.FindBlockFromString(1,ListObjects.SelectedItem.ToString());
				if(BlockToUse.Number!=-1) 
				{
					int zoff=BlockToUse.Offsetxyz>>2;
					if(zoff==0) maxz=3;
					else minz=(zoff*4)/12;
				}
			}
			for(int i=minz;i<=maxz;i++) this.ListZ.Items.Add(i);
		}

		//return values for use by calling system
		public string BlockName
		{
			get
			{
				return this.ListObjects.Text;
			}
		}
		public int XPosition
		{
			get
			{
				return Convert.ToInt32(this.ListX.Text);
			}
		}
		public int YPosition
		{
			get
			{
				return Convert.ToInt32(this.ListY.Text);
			}
		}
		public int ZPosition
		{
			get
			{
				if(this.ListZ.Text=="") return 0;	//only for cancel
				return Convert.ToInt32(this.ListZ.Text);
			}
		}
	}
}
